from sqlalchemy import create_engine
from enums.DatabaseDialectEnum import DatabaseDialectEnum
import logging

logger = logging.getLogger()


class Mariadb:

    def __init__(self, host: str, port: int, user: str, password: str, database: str) -> None:
        self.host = host
        self.port = port
        self.user = user
        self.password = password
        self.database = database
        self.engine = None

    def create_engine(self) -> None:
        try:
            dialect = DatabaseDialectEnum.MARIADB.value
            url = f"{dialect}://{self.user}:{self.password}@{self.host}:{str(self.port)}/{self.database}?charset=utf8mb4"
            self.engine = create_engine(url)
        except Exception as e:
            logger.error(f"Error creando engine de Mariadb. {e}")
